﻿package com.robotacid.engine {
	import flash.net.SharedObject;
	import com.robotacid.engine.LZW;
	
	/**
	* ...
	* @author Aaron Steed
	*/
	public class SavedGame {
		
		public var name:String;
		public var missiles:Array;
		public var g:Game;
		public var lzw:LZW;
		
		public function SavedGame(name:String, g:Game) {
			this.name = name;
			this.g = g;
			this.missiles = new Array();
			lzw = new LZW();
			load();
		}
		// Save data
		public function save():void{
			var so:SharedObject = SharedObject.getLocal(name);
			so.data.gun_health = g.gun.health.value;
			so.data.score = g.score.value;
			so.data.generation = g.launcher.generation;
			so.data.active = g.launcher.active;
			var temp:String;
			for(var i:int = 0; i < missiles.length; i++) {
				temp += missiles[i];
				if(i < missiles.length - 1) {
					temp += "|";
				}
			}
			so.data.missiles = lzw.compress(temp);
			so.flush();
			so.close();
		}
		// Load data
		public function load():Boolean {
			var so:SharedObject = SharedObject.getLocal(name);
			var exists:Boolean = false;
			for each(var a in so.data) {
				exists = true;
				break;
			}
			if(exists) {
				g.gun.health.value = so.data.gun_health;
				g.gun.drawBody();
				g.score.value = so.data.score;
				g.drawScore();
				g.launcher.generation = so.data.generation;
				g.launcher.active = so.data.active;
				g.launcher.decodeSavedMissiles(lzw.decompress(so.data.missiles));
				return true;
			}
			return false;
		}
	}
	
}