﻿package com.robotacid.engine_specific {
	import com.robotacid.engine.Dot;
	import com.robotacid.engine.Line;
	import flash.display.MovieClip;
	import flash.display.Shape;
	
	/**
	* Bullet
	* @author Aaron Steed
	*/
	public class Bullet extends Dot{
		
		public var vx:Number;
		public var vy:Number;
		public var dx:Number;
		public var dy:Number;
		public var px:Number;
		public var py:Number;
		public var speed:Number;
		public var radius:Number = 2;
		public var g:Game;
		public var active = true;
		public var mc:Shape;
		public var track:Line;
		public var charged:Boolean;
		
		public function Bullet(mc:Shape, x:Number, y:Number, dx:Number, dy:Number, speed:Number, g:Game, charged:Boolean) {
			super(x, y);
			this.g = g;
			this.dx = dx;
			this.dy = dy;
			this.speed = speed;
			this.mc = mc;
			this.charged = charged;
			vx = dx * speed;
			vy = dy * speed;
			if(charged) radius *= 2;
			draw();
			updateMC();
		}
		public function draw():void {
			mc.graphics.lineStyle(0, 0, 0);
			mc.graphics.beginFill(Game.FOREGROUND_COL);
			mc.graphics.drawCircle(0, 0, radius);
			mc.graphics.endFill();
		}
		public function main():void {
			px = x;
			py = y;
			if(track == null) {
			} else if(track != null && (track.b as Missile).active) {
				track.updateLine();
				vx = track.dx * speed;
				vy = track.dy * speed;
			} else {
				track = null;
			}
			x += vx;
			y += vy;
			//bitmap.x = ( -g.screen.x) + x;
			//bitmap.y = ( -g.screen.y) + y;
			updateMC();
		}
		public function toString():String{
			return "(" + x + "," + y + ")";
		}
		public function updateMC():void {
			mc.x = x;
			mc.y = y;
		}
	}
	
}